<template>
    <div class="edit-popup">
        <popup
            ref="popupRef"
            :title="popupTitle"
            :async="true"
            width="550px"
            @confirm="handleSubmit"
            @close="handleClose"
        >
            <el-form ref="formRef" :model="formData" label-width="90px" :rules="formRules">
                <el-form-item label="菜单名称" prop="title">
                    <el-input v-model="formData.title" clearable placeholder="请输入菜单名称" />
                    <div class="form-tips">推荐菜单为中文4个字符</div>
                </el-form-item>
                <el-form-item label="菜单描述" prop="remark">
                    <el-input
                        class="flex-1"
                        v-model="formData.remark"
                        type="textarea"
                        rows="4"
                        clearable
                        placeholder="请输入菜单描述"
                    />
                </el-form-item>
                <el-form-item label="菜单图标" prop="image">
                    <material-picker v-model="formData.image" />
                </el-form-item>
                <el-form-item label="文章状态" required prop="is_show">
                    <el-radio-group v-model="formData.is_show">
                        <el-radio :label="1">显示</el-radio>
                        <el-radio :label="2">隐藏</el-radio>
                    </el-radio-group>
                </el-form-item>
                <el-form-item label="显示权重" prop="sort">
                    <div>
                        <el-input-number v-model="formData.sort" :min="0" />
                        <div class="form-tips">默认为0， 数值越大越排前</div>
                    </div>
                </el-form-item>
                <el-form-item label="跳转地址" prop="navigate">
                    <el-input v-model="formData.navigate" clearable placeholder="请输入跳转地址" />
                </el-form-item>
                <el-form-item label="显示位置" prop="position">
                    <el-select
                        class="flex-1"
                        v-model="formData.position"
                        clearable
                        placeholder="请选择显示位置"
                    >
                        <el-option
                            v-for="(item, index) in dictData.menu_position"
                            :key="index"
                            :label="item.name"
                            :value="item.value"
                        />
                    </el-select>
                </el-form-item>
                <el-form-item label="用户平台" prop="platform">
                    <el-select
                        class="flex-1"
                        v-model="formData.platform"
                        clearable
                        placeholder="请选择用户平台"
                    >
                        <el-option
                            v-for="(item, index) in dictData.platform"
                            :key="index"
                            :label="item.name"
                            :value="item.value"
                        />
                    </el-select>
                </el-form-item>
            </el-form>
        </popup>
    </div>
</template>

<script lang="ts" setup name="menuEdit">
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { apiMenuAdd, apiMenuEdit, apiMenuDetail } from '@/api/menu'
import type { PropType } from 'vue'
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')

// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑用户端菜单' : '新增用户端菜单'
})

// 表单数据
const formData = reactive({
    id: '',
    title: '',
    remark: '',
    image: '',
    is_show: 1,
    sort: 0,
    navigate: '',
    platform: '',
    position: ''
})

// 表单验证
const formRules = reactive<any>({
    title: [
        {
            required: true,
            message: '请输入菜单名称',
            trigger: ['blur']
        }
    ],
    image: [
        {
            required: true,
            message: '请选择菜单图标',
            trigger: ['blur']
        }
    ],
    is_show: [
        {
            required: true,
            message: '请输入显示状态',
            trigger: ['blur']
        }
    ],
    sort: [
        {
            required: true,
            message: '请输入显示权重',
            trigger: ['blur']
        }
    ],
    platform: [
        {
            required: true,
            message: '请选择用户平台',
            trigger: ['blur']
        }
    ],
    position: [
        {
            required: true,
            message: '请选择显示位置',
            trigger: ['blur']
        }
    ]
})

// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }
}

const getDetail = async (row: Record<string, any>) => {
    const data = await apiMenuDetail({
        id: row.id
    })
    setFormData(data)
}

// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate()
    const data = { ...formData }
    mode.value == 'edit' ? await apiMenuEdit(data) : await apiMenuAdd(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}

defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
